#ifndef PLANE_H_
#define PLANE_H_

#include "vec.h"

class Plane {
public :
	Vec _pos; // position du centre
	Vec _normal; // normale au plan
	Vec _vel; // velocit
	double _mass; // masse
	double _invMass; // inverse de la masse

public :
	Plane(){
		_pos = Vec();
		_normal = Vec(0,1,0);
		_vel = Vec();
		_mass = 0.0; // objet cr statique
		_invMass = 0.0;
	};

	Plane(Vec pos, Vec normal, Vec vel, double mass) {
		_pos = pos;
		_normal = normal;
		_vel = vel;
		_mass = mass;
		if (_mass>0) {
			_invMass = 1.0/mass;
		} else {
			_invMass = 0.0;
		}
	}

	~Plane(){};
};

#endif