#include "solver.h"

void Solver::dynamicsForce(Vec x, Vec* r) {
	r->x = derivee.x;
	r->y = derivee.y;
	r->z = derivee.z;
}

void Solver::decayForce(Vec x, Vec* r) {
	r->x = 1;
	r->y = -_k*x.y;
	r->z = 0.0;
}

void Solver::J_decayForce(Vec x, Matrix* J) {
	J->setVal(0,0, 0.0);
	J->setVal(1,0, 0.0);
	J->setVal(0,1,  0.0);
	J->setVal(1,1, -_k);
}

void Solver::circularForce(Vec x, Vec* r) {
   double d;
   d = 1;
   r->x = -x.y/d;
   r->y = x.x/d;
   r->z = 0.0;
}

void Solver::J_circularForce(Vec x, Matrix* J) {
	J->setVal(0,0, 0.0);
	J->setVal(1,0, 1.0);
	J->setVal(0,1, -1.0);
	J->setVal(1,1, 0.0);
}

void Solver::eulerExpFixStep() {
	///////////////////////////////////////
	//////////////// TO DO ////////////////
	///////////////////////////////////////
};
void Solver::eulerExpVarStep() {
	///////////////////////////////////////
	//////////////// TO DO ////////////////
	///////////////////////////////////////
};
void Solver::eulerImp() {
	///////////////////////////////////////
	//////////////// TO DO ////////////////
	///////////////////////////////////////
};


void Solver::callMethod() {
	switch(_method) {
		case 10 :
			eulerExpFixStep();
			break;
		case 11 :
			eulerExpVarStep();
			break;
		case 12 :
			eulerImp();
			break;
	}
}

void Solver::setJacobien(Vec x, Matrix* J) {
	switch(_problem) {
		case 0 :
			J_decayForce(x,J);
			break;
		case 1:
			J_circularForce(x,J);
			break;
	}
}

void Solver::callProblem(Vec x, Vec* r) {
	switch(_problem) {
		case P_DECAY :
			decayForce(x,r);
			break;
		case P_CIRCLE :
			circularForce(x,r);
			break;
		case P_DYNAMICS :
			dynamicsForce(x,r);
	}
}

void Solver::resetPos() {
	pos.x = pos0.x;
	pos.y = pos0.y;
	pos.z = pos0.z;
}

